#
# Conditional build:
%bcond_without	python2	# CPython 2.x module
%bcond_without	python3	# CPython 3.x module
%bcond_with	tests	# pytest tests
%bcond_without	doc	# Sphinx documentation

Summary:	The modular source code checker: pycodestyle, pyflakes and co.
Summary(pl.UTF-8):	Modularne narzędzie do sprawdzania kodu źródłowego: pycodestyle, pyflakes itp.
Name:		flake8
# before updating to 4.x fork python-flake8.spec with last 3.x version
Version:	3.9.2
Release:	3
License:	MIT
Group:		Development/Tools
#Source0Download: https://pypi.org/simple/flake8/
Source0:	https://files.pythonhosted.org/packages/source/f/flake8/%{name}-%{version}.tar.gz
# Source0-md5:	5c102972d3d0f35255c56a20613fcec5
Patch0:		%{name}-duplicate.patch
URL:		https://gitlab.com/pycqa/flake8
BuildRequires:	rpmbuild(macros) >= 1.714
BuildRequires:	rpm-pythonprov
%if %{with python2}
BuildRequires:	python-modules >= 1:2.7
BuildRequires:	python-setuptools >= 1:30
%if %{with tests}
BuildRequires:	python-configparser
BuildRequires:	python-enum34
BuildRequires:	python-functools32
BuildRequires:	python-importlib_metadata
BuildRequires:	python-mccabe >= 0.6.0
BuildRequires:	python-mccabe < 0.7.0
BuildRequires:	python-mock >= 2.0.0
BuildRequires:	python-pycodestyle >= 2.7.0
BuildRequires:	python-pycodestyle < 2.8.0
BuildRequires:	python-pyflakes >= 2.3.0
BuildRequires:	python-pyflakes < 2.4.0
BuildRequires:	python-pytest
BuildRequires:	python-typing
%endif
%endif
%if %{with python3}
BuildRequires:	python3-modules >= 1:3.5
BuildRequires:	python3-setuptools >= 1:30
%if %{with tests}
%if "%{py3_ver}" < "3.8"
BuildRequires:	python3-importlib_metadata
%endif
BuildRequires:	python3-mccabe >= 0.6.0
BuildRequires:	python3-mccabe < 0.7.0
BuildRequires:	python3-pycodestyle >= 2.7.0
BuildRequires:	python3-pycodestyle < 2.8.0
BuildRequires:	python3-pyflakes >= 2.3.0
BuildRequires:	python3-pyflakes < 2.4.0
BuildRequires:	python3-pytest
BuildRequires:	sed >= 4.0
%endif
%endif
%if %{with doc}
BuildRequires:	python3-sphinx-prompt
BuildRequires:	sphinx-pdg-3 >= 1.3
%endif
%if %{with python3}
Requires:	python3-flake8 = %{version}-%{release}
%else
Requires:	python-flake8 = %{version}-%{release}
%endif
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The modular source code checker. It is a wrapper around these tools:
- PyFlakes
- pycodestyle
- Ned Batchelder's McCabe script

%description -l pl.UTF-8
Modularne narzędzie do sprawdzania kodu źródłowego. Jest to opakowanie
dla narzędzi:
- PyFlakes
- pycodestyle
- skrypt McCabe autorstwa Neda Batcheldera

%package -n python-flake8
Summary:	The modular source code checker: pycodestyle, pyflakes and co.
Summary(pl.UTF-8):	Modularne narzędzie do sprawdzania kodu źródłowego: pycodestyle, pyflakes itp.
Group:		Libraries/Python
Requires:	python-mccabe >= 0.6.0
Requires:	python-mccabe < 0.7.0
Requires:	python-modules >= 1:2.7
Requires:	python-pycodestyle >= 2.7.0
Requires:	python-pycodestyle < 2.8.0
Requires:	python-pyflakes >= 2.3.0
Requires:	python-pyflakes < 2.4.0

%description -n python-flake8
The modular source code checker. It is a wrapper around these tools:
- PyFlakes
- pycodestyle
- Ned Batchelder's McCabe script

%description -n python-flake8 -l pl.UTF-8
Modularne narzędzie do sprawdzania kodu źródłowego. Jest to opakowanie
dla narzędzi:
- PyFlakes
- pycodestyle
- skrypt McCabe autorstwa Neda Batcheldera

%package -n python3-flake8
Summary:	The modular source code checker: pycodestyle, pyflakes and co
Summary(pl.UTF-8):	Modularne narzędzie do sprawdzania kodu źródłowego: pycodestyle, pyflakes itp.
Group:		Libraries/Python
Requires:	python3-mccabe >= 0.6.0
Requires:	python3-mccabe < 0.7.0
Requires:	python3-modules >= 1:3.4
Requires:	python3-pycodestyle >= 2.7.0
Requires:	python3-pycodestyle < 2.8.0
Requires:	python3-pyflakes >= 2.3.0
Requires:	python3-pyflakes < 2.4.0

%description -n python3-flake8
The modular source code checker. It is a wrapper around these tools:
- PyFlakes
- pycodestyle
- Ned Batchelder's McCabe script

%description -n python3-flake8 -l pl.UTF-8
Modularne narzędzie do sprawdzania kodu źródłowego. Jest to opakowanie
dla narzędzi:
- PyFlakes
- pycodestyle
- skrypt McCabe autorstwa Neda Batcheldera

%package -n python-flake8-apidocs
Summary:	API documentation for Python flake8 module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona flake8
Group:		Documentation

%description -n python-flake8-apidocs
API documentation for Python flake8 module.

%description -n python-flake8-apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona flake8.

%prep
%setup -q
%patch0 -p1

%build
%if %{with python2}
%py_build

%if %{with tests}
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTHONPATH=$(pwd)/src \
%{__python} -m pytest -rw tests
%endif
%endif

%if %{with python3}
# don't require standalone mock
%{__sed} -i -e 's/import mock/from unittest import mock/' $(grep 'import mock' tests/ -rl)

%py3_build

%if %{with tests}
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTHONPATH=$(pwd)/src \
%{__python3} -m pytest -rw tests
%endif
%endif

%if %{with doc}
cd docs/source
PYTHONPATH=$(pwd)/../../src \
sphinx-build-3 -b html . _build/html
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%py_install
%{__mv} $RPM_BUILD_ROOT%{_bindir}/flake8{,-2}
%py_postclean
%endif

%if %{with python3}
%py3_install
%{__mv} $RPM_BUILD_ROOT%{_bindir}/flake8{,-3}
%endif

ln -s flake-%{!?with_python3:2}%{?with_python3:3} $RPM_BUILD_ROOT%{_bindir}/flake8

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/flake8

%if %{with python2}
%files -n python-flake8
%defattr(644,root,root,755)
%doc CONTRIBUTORS.txt LICENSE README.rst
%attr(755,root,root) %{_bindir}/flake8-2
%{py_sitescriptdir}/flake8
%{py_sitescriptdir}/flake8-%{version}-py*.egg-info
%endif

%if %{with python3}
%files -n python3-flake8
%defattr(644,root,root,755)
%doc CONTRIBUTORS.txt LICENSE README.rst
%attr(755,root,root) %{_bindir}/flake8-3
%{py3_sitescriptdir}/flake8
%{py3_sitescriptdir}/flake8-%{version}-py*.egg-info
%endif

%if %{with doc}
%files -n python-flake8-apidocs
%defattr(644,root,root,755)
%doc docs/source/_build/html/{_modules,_static,internal,plugin-development,release-notes,user,*.html,*.js}
%endif
%changelog
* Fri Apr 01 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/flake8.git;a=log;h=master

* Fri Apr 01 2022 Jan Rękorajski <baggins@pld-linux.org> 1ae4453
- Release 3 (by relup.sh)

* Fri Apr 01 2022 Jan Rękorajski <baggins@pld-linux.org> bde5aaa
- disable tests, broken at least on python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 194a8cf
- rebuild with python 3.10

* Tue Mar 15 2022 Jakub Bogusz <qboosh@pld-linux.org> e6703be
- updated to 3.9.2
- removed obsolete req patch

* Mon Mar 01 2021 Jan Palus <atler@pld-linux.org> 9c76640
- explicit runtime deps on python-{entrypoints,mccabe,pycodestyle,pyflakes}; rel 3

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> a712f07
- release 2 (by relup.sh)

* Sun Jan 12 2020 Jakub Bogusz <qboosh@pld-linux.org> 2fc1c08
- updated to 3.7.9
- added duplicate patch (fixes tests with python-flake8 already installed)

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 74c2b4b
- rebuild with python 3.8
- release 2 (by relup.sh)

* Tue Oct 22 2019 Jakub Bogusz <qboosh@pld-linux.org> 7b99a73
- added req patch: adjust entrypoints versions to be compatible with rpm dependency generators

* Tue Oct 22 2019 Jakub Bogusz <qboosh@pld-linux.org> 1820387
- updated to 3.7.8
- removed outdated mock patch

* Sun Jul 22 2018 Jakub Bogusz <qboosh@pld-linux.org> 34073ed
- updated to 3.5.0
- added -apidocs

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 975a3e6
- release 3 (by relup.sh)

* Mon Apr 17 2017 Jakub Bogusz <qboosh@pld-linux.org> d7cb1eb
- updated descriptions and dependencies
- added mock patch and sed substitution (use unittest.mock under python3)

* Sat Apr 15 2017 Jan Rękorajski <baggins@pld-linux.org> 972dfbb
- typo

* Sat Apr 15 2017 Jan Rękorajski <baggins@pld-linux.org> 5312367
- updated BRs
- rel 2

* Sat Apr 15 2017 Jan Rękorajski <baggins@pld-linux.org> 7db5e8a
- removed obsolete patch

* Sat Apr 15 2017 Jan Rękorajski <baggins@pld-linux.org> 9bc90c2
- up to 3.3.0
- updated BRs

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 3643ee8
- python 3.6
- release 2 (by relup.sh)

* Fri Mar 25 2016 Jakub Bogusz <qboosh@pld-linux.org> 19c415b
- added dependencies patch (bump maximum pyflakes version)

* Mon Mar 21 2016 Elan Ruusamäe <glen@delfi.ee> 8b0b670
- use symlink

